/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.TipoParada;
import com.rjconsultores.ventaboletos.service.TipoParadaService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarTipoParadaController")
@Scope("prototype")
public class EditarTipoParadaController extends MyGenericForwardComposer {

    @Autowired
    private TipoParadaService tipoParadaService;
    private TipoParada tipoParada;
    private MyListbox tipoParadaList;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarTipoParadaController.class);
    private Textbox txtNome;
    private Row rowEquivalencia;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public TipoParada getTipoParada() {
        return tipoParada;
    }

    public void setTipoParada(TipoParada tipoParada) {
        this.tipoParada = tipoParada;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoParada = (TipoParada) Executions.getCurrent().getArg().get("tipoParada");
        tipoParadaList = (MyListbox) Executions.getCurrent().getArg().get("tipoParadaList");

        if (tipoParada.getTipoparadaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

//        Comentado pois estava dando erro no SCIA
//        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
//            rowEquivalencia.setVisible(Boolean.FALSE);
//        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        try {
            tipoParada.setActivo(true);
            tipoParada.setFecmodif(Calendar.getInstance().getTime());
            tipoParada.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<TipoParada> lsTipoParada = tipoParadaService.buscar(tipoParada.getDesctipo());

            if (!lsTipoParada.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTipoParadaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (tipoParada.getTipoparadaId() == null) {
                    tipoParadaService.suscribir(tipoParada);
                    tipoParadaList.addItem(tipoParada);
                } else {
                    tipoParadaService.actualizacion(tipoParada);
                    tipoParadaList.updateItem(tipoParada);
                }

                Messagebox.show(
                        Labels.getLabel("editarTipoParadaController.MSG.suscribirOK"),
                        Labels.getLabel("editarTipoParadaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarTipoParadaController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoParadaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTipoParadaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarTipoParadaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                tipoParadaService.borrar(tipoParada);

                Messagebox.show(
                        Labels.getLabel("editarTipoParadaController.MSG.borrarOK"),
                        Labels.getLabel("editarTipoParadaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tipoParadaList.removeItem(tipoParada);

                closeWindow();
            }
        } catch (RegistroConDependenciaException ex) {
            Clients.alert(
                    ex.getLocalizedMessage(),
                    Labels.getLabel("editarTipoParadaController.window.title"),
                    Messagebox.INFORMATION);
        } catch (Exception ex) {
            log.error(ex);

            Clients.alert(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoParadaController.window.title"),
                    Messagebox.INFORMATION);

        }
    }
}
